'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _levelup = require('levelup');

var _levelup2 = _interopRequireDefault(_levelup);

var _mongodown = require('mongodown');

var _mongodown2 = _interopRequireDefault(_mongodown);

var _levelgraph = require('levelgraph');

var _levelgraph2 = _interopRequireDefault(_levelgraph);

var _levelgraphRecursive = require('levelgraph-recursive');

var _levelgraphRecursive2 = _interopRequireDefault(_levelgraphRecursive);

var _concepts = require('./concepts');

var _concepts2 = _interopRequireDefault(_concepts);

var _expand = require('./expand');

var _expand2 = _interopRequireDefault(_expand);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var create = function create(dbName, cb) {
  if (cb) {
    (0, _levelup2.default)(dbName, { db: _mongodown2.default }, function (err, leveldb) {
      var db = (0, _levelgraphRecursive2.default)((0, _levelgraph2.default)(leveldb));
      if (cb) {
        cb(err, (0, _expand2.default)(db, leveldb));
      }
    });
  } else {
    var leveldb = (0, _levelup2.default)(dbName, { db: _mongodown2.default });
    var db = (0, _levelgraphRecursive2.default)((0, _levelgraph2.default)(leveldb));
    return (0, _expand2.default)(db, leveldb);
  }
};

// This loads a global DB
var load = function load(files, dbName, cb) {
  (0, _levelup2.default)(dbName, { db: _mongodown2.default }, function (err, leveldb) {
    if (err) {
      return cb(err);
    }
    var db = (0, _levelgraphRecursive2.default)((0, _levelgraph2.default)(leveldb));
    _concepts2.default.readFiles(files, db, function (err2, db2) {
      cb(err2, (0, _expand2.default)(db, leveldb));
    });
  });
};

exports.default = {
  create: create,
  load: load
};